unit Kurvdr_u;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Printers;

type
  TKurveFormular = class(TForm)
    Endeknopf: TBitBtn;
    Druckekopf: TButton;
    procedure DruckekopfClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  KurveFormular: TKurveFormular;

implementation
{$R *.DFM}

var Einheit:  Integer;
    Ursprung: Record i,j: Integer end;

function f(x: Real): Real;
begin
  f := cos(x);
end;

procedure TKurveFormular.FormActivate(Sender: TObject);
begin
  Einheit := 100;              {KurveFormular wurde durch  Printer ersetzt}
  With Printer do begin
    Ursprung.i := PageWidth Div 2;  Ursprung.j := PageHeight Div 4;
    Canvas.Pen.Color := clBlack;     {Statt Width  heit es jetzt:  PageWidth }
  end;                               {Statt Height heit es jetzt:  PageHeight}
end;

procedure Achsenzeichnen;
begin
  With Printer do begin
    Canvas.moveto(0,Ursprung.j);  Canvas.lineto(PageWidth,Ursprung.j);
    Canvas.moveto(Ursprung.i,0);  Canvas.lineto(Ursprung.i,PageHeight DIV 2);
  end;
end;

procedure KurveDrucken;
var i,j: Integer;
    x,y: Real;
begin
  With Printer do begin
    i := 0;   x := (i - Ursprung.i) / Einheit;
    y := f(x);
    j := -round(y*Einheit) + Ursprung.j;
    canvas.moveto(i,j);
    for i := 1 to PageWidth do begin
      x := (i - Ursprung.i) / Einheit;
      y := f(x);
      j := -round(y*Einheit) + Ursprung.j;
      canvas.lineto(i,j);
    end;
  end;
end;

procedure TKurveFormular.DruckekopfClick(Sender: TObject);
begin
  Printer.BeginDoc;   {Starte Druckauftrag}
  Achsenzeichnen;
  KurveDrucken;
  Printer.EndDoc;     {Beende Druckauftrag. Erst jetzt wird die im Speicher}
end;                  {auf das "Druckerformular" gezeichnete Seite gedruckt}

end.
