unit Lotto_u;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Lottoknopf: TButton;
    EndeKnopf: TButton;
    LottoBox: TListBox;
    Sortierknopf: TButton;
    Loeschknopf: TButton;
    procedure EndeKnopfClick(Sender: TObject);
    procedure LottoknopfClick(Sender: TObject);
    procedure SortierknopfClick(Sender: TObject);
    procedure LoeschknopfClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.EndeKnopfClick(Sender: TObject);
begin
  close
end;

procedure TForm1.LottoknopfClick(Sender: TObject);
Var i,j,z: INTEGER;
    neuezahl: BOOLEAN;
    Lottozahl: Array[1..6] of Integer;
    s: String;
Begin
  lottozahl[1]:= 0;
  randomize;
  FOR i:=1 TO 6 DO BEGIN
    REPEAT
      z:= random(49) + 1;
      neuezahl:= TRUE;
      FOR j:=1 TO i DO IF z = lottozahl[j] THEN neuezahl:= FALSE;
    UNTIL neuezahl;
    lottozahl[i] := z;
  END;
  For i := 1 to 6 do begin
    s := inttostr(Lottozahl[i]);
    If length(s)=1 then s := ' ' + s;
    LottoBox.Items.add(s);
  end;
end;

procedure TForm1.SortierknopfClick(Sender: TObject);
begin
  Lottobox.Sorted := True;
end;

procedure TForm1.LoeschknopfClick(Sender: TObject);
begin
  LottoBox.Clear;
  LottoBox.Sorted := False;
end;

end.
