unit Magqu_u;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Grids, ExtCtrls;

type
  TMagquadForm = class(TForm)
    MagFeld: TStringGrid;
    Panel1: TPanel;
    ErzeugKnopf: TBitBtn;
    Anzfeld: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Endeknopf: TButton;
    procedure AnzfeldChange(Sender: TObject);
    procedure EndeknopfClick(Sender: TObject);
    procedure ErzeugKnopfClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  MagquadForm: TMagquadForm;

implementation
{$R *.DFM}

TYPE Magquad = ARRAY[1..23,1..23] OF INTEGER;

VAR quadrat: Magquad;
    zeilenzahl,n: INTEGER;

PROCEDURE erzeuge;
VAR zahl, i, j: INTEGER;
FUNCTION nachfolger(k: INTEGER): INTEGER;
BEGIN   { von nachfolger }
  IF k < zeilenzahl THEN nachfolger:= k+1
                    ELSE nachfolger:= 1
END;
FUNCTION vorgaenger(k: INTEGER): INTEGER;
BEGIN    { von vorgaenger }
  IF k > 1 THEN vorgaenger:= k-1
           ELSE vorgaenger:= zeilenzahl
END;
BEGIN   (* von erzeuge *)
  If Zeilenzahl Mod 2 = 0 then Zeilenzahl := Zeilenzahl + 1;
  MagquadForm.AnzFeld.Text := IntToStr(Zeilenzahl);
  MagquadForm.Magfeld.Rowcount := Zeilenzahl;
  MagquadForm.Magfeld.Colcount := Zeilenzahl;
  n:= zeilenzahl * zeilenzahl;
  FOR i:= 1 TO zeilenzahl DO
    FOR j:= 1 TO zeilenzahl DO MagquadForm.MagFeld.Cells[i-1,j-1] := '0';
  j:= zeilenzahl DIV 2;
  i:= j+1;
  FOR zahl:= 1 TO n DO BEGIN
    i:= nachfolger(i); j:= nachfolger(j);
    WHILE MagquadForm.MagFeld.Cells[i-1,j-1] > '0' DO BEGIN
      i:= nachfolger(i); j:= vorgaenger(j);
    END;
    MagquadForm.MagFeld.Cells[i-1,j-1] := IntToStr(zahl);
  END;
END;


procedure TMagquadForm.AnzfeldChange(Sender: TObject);
begin
  If Anzfeld.Text<>'' then Zeilenzahl := StrToInt(Anzfeld.Text)
                      else Zeilenzahl := 1;
end;

procedure TMagquadForm.EndeknopfClick(Sender: TObject);
begin
  close
end;

procedure TMagquadForm.ErzeugKnopfClick(Sender: TObject);
begin
  Erzeuge;
end;

end.
