unit Zeich;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus;

type
  TKunstForm = class(TForm)
    MainMenu1: TMainMenu;
    Zeichnung1: TMenuItem;
    NeuesBild1: TMenuItem;
    LoescheBild1: TMenuItem;
    N1: TMenuItem;
    Ende1: TMenuItem;
    procedure Ende1Click(Sender: TObject);
    procedure LoescheBild1Click(Sender: TObject);
    procedure NeuesBild1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  KunstForm: TKunstForm;

implementation

{$R *.DFM}

procedure TKunstForm.Ende1Click(Sender: TObject);
begin
   close
end;

procedure TKunstForm.LoescheBild1Click(Sender: TObject);
var r: trect;    {Type trect: siehe integrierter Hilfe}
begin
  canvas.brush.color := clSilver; {oder clBtnFace}
  r.left := 0; r.top := 0;  r.right := width;  r.bottom := height;
                     {width und height sind Eigenschaften des Formulars}
  canvas.fillrect(r);  { fllt Rechteck r mit canvas.brush.color }
end;

procedure TKunstForm.NeuesBild1Click(Sender: TObject);
begin
  With Canvas do begin  {Canvas = Formularoberflche, linke obere Ecke: (0,0) }
    {Linie zeichnen}
    pen.width := 10;  pen.color := clnavy;     {Stifteigenschaften festlegen}
    moveto(30,50); {Anfangspunkt setzen}
    lineto(300,200);

    {Rechteck oder Ellipse zeichnen}    {brush... legt Flleigenschaften fest}
    pen.width := 2;  pen.color := clblue;   brush.color := clgreen;
    rectangle(80,30,180,200);
    pen.width := 5;  pen.color := clteal;   brush.color := clred;
    ellipse(100,60,300,150);

    {Polygon zeichnen}     {Parameter: Menge von Punkten}
    pen.width := 1;  pen.color := clgreen;   brush.color := clyellow;
    Brush.Color := clyellow;
    Polygon([Point(10,200), Point(100,10),Point(300,20), Point(50,50)]);

    {Textausgabe auf der Zeichenflche}
    brush.color := clwhite;
    font.name := 'Times New Roman'; font.size := 18;  font.color := clpurple;
    textout(50,100,' Ist das jetzt Kunst oder was?? ');
  end;
end;

end.
